## gcovr 5.0

=== Makefile ===
# This Makefile helps perform some developer tasks, like linting or testing.
# Run `make` or `make help` to see a list of tasks.

# Override the environment variables to hide the values from the test drivers
unexport MFLAGS
unexport MAKEFLAGS

# Set a variable if it's empty or provided by `make`.
# usage: $(call set_sensible_default, NAME, value)
set_sensible_default = $(if $(filter undefined default,$(origin $(1))),$(2),$(value $(1)))

PYTHON := $(call set_sensible_default,PYTHON,python3)

override AVAILABLE_CC := gcc-5 gcc-6 gcc-8

# Setting CXX and GCOV depending on CC. Only CC has to be set to a specific version.
# If using GitHub actions on Windows, gcc-8 is set but gcc is used, so we override it.
CC := $(call set_sensible_default,CC,gcc-5)
ifeq ($(filter $(CC),$(AVAILABLE_CC)),)
$(error Unsupported version of GCC used. CC must be one of: $(AVAILABLE_CC))
endif
export CC := $(CC)
CXX := $(call set_sensible_default,CXX,$(subst gcc,g++,$(CC)))
export CXX := $(CXX)
GCOV := $(call set_sensible_default,GCOV,$(subst gcc,gcov,$(CC)))

USERID  := $(shell id -u $(USER))
QA_CONTAINER ?= gcovr-qa-$(CC)-uid_$(USERID)
TEST_OPTS ?=
ifeq ($(USE_COVERAGE),true)
override TEST_OPTS += --cov=gcovr --cov-branch
endif

.PHONY: help setup-dev qa lint test doc docker-qa docker-qa-build

help:
	@echo "select one of the following targets:"
	@echo "  help       print this message"
	@echo "  setup-dev  prepare a development environment"
	@echo "  qa         run all QA tasks (lint, test, doc)"
	@echo "  lint       run the flake8 linter"
	@echo "  test       run all tests"
	@echo "  doc        render the docs"
	@echo "  docker-qa  run qa in the docker container"
	@echo "  docker-qa-build"
	@echo "             build the qa docker container"
	@echo ""
	@echo "environment variables:"
	@echo "  PYTHON     Python executable to use [current: $(PYTHON)]"
	@echo "  CC, CXX, GCOV"
	@echo "             the gcc version to use [current: CC=$(CC) CXX=$(CXX) GCOV=$(GCOV)]"
	@echo "  TEST_OPTS  additional flags for pytest [current: $(TEST_OPTS)]"
	@echo "  USE_COVERAGE  if true extend TEST_OPTS with flags for generating coverage data"
	@echo "  QA_CONTAINER"
	@echo "             tag for the qa docker container [current: $(QA_CONTAINER)]"

setup-dev:
	$(PYTHON) -m pip install --upgrade pip
	$(PYTHON) -m pip install -r requirements.txt -r doc/requirements.txt
	$(PYTHON) -m pip install -e .
	$(PYTHON) --version
ifeq ($(CI),true)
ifeq ($(shell which $(CC) 2>/dev/null),)
	cd $(dir $(shell which gcc 2>/dev/null)) && cp -f gcc.exe $(CC).exe
endif
	$(CC) --version
ifeq ($(shell which $(CXX) 2>/dev/null),)
	cd $(dir $(shell which g++ 2>/dev/null)) && cp -f g++.exe $(CXX).exe
endif
	$(CXX) --version
ifeq ($(shell which $(GCOV) 2>/dev/null),)
	cd $(dir $(shell which gcov 2>/dev/null)) && cp -f gcov.exe $(GCOV).exe
endif
endif
	$(GCOV) --version

qa: doc lint check-format test doc

lint:
	$(PYTHON) -m flake8 doc gcovr

check-format:
	$(PYTHON) -m black --diff doc gcovr

test: export GCOVR_TEST_SUITE := 1
test: export CC := $(CC)
test: export CXX := $(CXX)
test: export GCOV := $(GCOV)

test:
	$(PYTHON) -m pytest -v --doctest-modules $(TEST_OPTS) -- gcovr doc/examples

doc:
	cd doc && make html O=-W

docker-qa: export TEST_OPTS := $(TEST_OPTS)
docker-qa: export GCOVR_ISOLATED_TEST := zkQEVaBpXF1i

docker-qa: | docker-qa-build
	docker run --rm -e TEST_OPTS -e GCOVR_ISOLATED_TEST -v `pwd`:/gcovr $(QA_CONTAINER)

docker-qa-build: admin/Dockerfile.qa requirements.txt doc/requirements.txt
	docker build --tag $(QA_CONTAINER) \
		--build-arg USERID=$(USERID) \
		--build-arg CC=$(CC) --build-arg CXX=$(CXX) --file $< .

=== requirements.txt ===
black; implementation_name == "cpython"
cmake
flake8
jinja2
lxml
pygments == 2.7.4
pytest
pytest-cov
pyutilib
coverage
codecov
wheel

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = gcovr
SOURCEDIR     = source
BUILDDIR      = build

PYTHON ?= python
SCREENSHOT_FROM_HTML = wkhtmltoimage --width 700 --quality 5
SCREENSHOTS = images/screenshot-html.png images/screenshot-html-details.example.cpp.png

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile all outputs clean tests clean-images

# keep the screenshots
.PRECIOUS: $(SCREENSHOTS)

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile $(SCREENSHOTS) outputs
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

images/screenshot-%.png: examples/example-%.html
	$(SCREENSHOT_FROM_HTML) $< $@

examples/example-%.html:
	cd examples; ./example_html.sh

outputs:
	gcovr -h > examples/gcovr.out

tests:
	$(PYTHON) -m pytest examples -v

clean-images:
	rm -f $(SCREENSHOTS)

=== doc/requirements.txt ===
sphinx
sphinx_rtd_theme
sphinxcontrib-autoprogram == 0.1.5 ; python_version == "3.6"
sphinxcontrib-autoprogram >= 0.1.5 ; python_version >= "3.7"

=== doc/examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12)
project("GCOVR Example"
        LANGUAGES CXX)

#BEGIN cmakecmds
add_compile_options("--coverage")

add_executable(program example.cpp)
target_link_libraries(program gcov)
#END cmakecmds

=== gcovr/tests/add_coverages/Makefile ===
CFLAGS= -fprofile-arcs -ftest-coverage -fPIC

all:
	$(CXX) $(CFLAGS) -c foo.cpp -o foo.o
	$(CXX) $(CFLAGS) -c bar.cpp -o bar.o
	$(CXX) $(CFLAGS) -DFOO -c main.cpp -o main_foo.o
	$(CXX) $(CFLAGS) main_foo.o foo.o -o testcase_foo
	$(CXX) $(CFLAGS) -DBAR -c main.cpp -o main_bar.o
	$(CXX) $(CFLAGS) main_bar.o bar.o -o testcase_bar

run: txt xml html sonarqube json json_summary coveralls

# Enable JSON output via the --json-pretty mode.
# However, this option cannot take a filename directly
# so that "-o" is used.
coverage_foo.json:
	./testcase_foo
	$(GCOVR) -d --json-pretty -o $@

# Just use --json and pass the output filename directly.
coverage_bar.json:
	./testcase_bar
	$(GCOVR) -d --json $@

txt: coverage_foo.json coverage_bar.json
	$(GCOVR) -a coverage_foo.json -a coverage_bar.json -o coverage.txt

xml: coverage_foo.json coverage_bar.json
	$(GCOVR) -a coverage_foo.json -a coverage_bar.json -x -o coverage.xml

html: coverage_foo.json coverage_bar.json
	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --html-details -o coverage.html

sonarqube: coverage_foo.json coverage_bar.json
	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --sonarqube sonarqube.xml

# Use both --json and --json-pretty here
json: coverage_foo.json coverage_bar.json
	$(GCOVR) -a 'coverage_*.json' --json-pretty --json coverage.json

json_summary: coverage_foo.json coverage_bar.json
	$(GCOVR) -a 'coverage_*.json' --json-summary-pretty -o summary_coverage.json

coveralls: coverage_foo.json coverage_bar.json
	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --coveralls-pretty --coveralls coveralls.json

clean:
	rm -f testcase_*
	rm -f *.gc*
	rm -f *.o
	rm -f coverage*.* sonarqube*.* summary_coverage.json coveralls.json

=== gcovr/tests/bad++char/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: txt xml html sonarqube json_summary coveralls

coverage.json:
	./testcase
	$(GCOVR) --json coverage.json

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

xml: coverage.json
	$(GCOVR) -a $< -x -o coverage.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

coveralls: coverage.json
	$(GCOVR) -a $< --coveralls coveralls.json

json_summary:
	./testcase
	$(GCOVR) -d --json-summary-pretty -o summary_coverage.json

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.* sonarqube*.* summary_coverage.json coveralls.json

=== gcovr/tests/cmake_oos/CMakeLists.txt ===

cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

project(gcovrtest)

    add_executable(gcovrtest main.cpp)

=== gcovr/tests/cmake_oos/Makefile ===
# Original build.sh script from ticket:
#   rm -fr build
#   mkdir build
#   cd build
#   cmake ..
#   make
#   gcovrtest

BASE_OS:=$(shell uname | cut -d'-' -f1)
ifeq ($(BASE_OS),MSYS_NT)
  CMAKE_GENERATOR := "MSYS Makefiles"
else
  CMAKE_GENERATOR := "Unix Makefiles"
endif

all:
	@echo "CC:   ${CC} (origin: $(origin CC))"
	@echo "CXX:  ${CXX} (origin: $(origin CXX))"
	@echo "GCOV: ${GCOV} (origin: $(origin GCOV))"
	mkdir -p build
	cd build && cmake -G $(CMAKE_GENERATOR) -DCMAKE_BUILD_TYPE=PROFILE -DCMAKE_TOOLCHAIN_FILE=../Toolchain.cmake .. && make

run: txt xml html sonarqube coveralls

coverage.json:
	cd build && ./gcovrtest
	$(GCOVR) --json coverage.json

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

xml: coverage.json
	$(GCOVR) -a $< -x -o coverage.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build
	rm -f coverage*.* sonarqube*.* coveralls.json

=== gcovr/tests/cmake_oos_ninja/Makefile ===

all:
	@echo "CC:   ${CC} (origin: $(origin CC))"
	@echo "CXX:  ${CXX} (origin: $(origin CXX))"
	@echo "GCOV: ${GCOV} (origin: $(origin GCOV))"
	cmake -DCMAKE_TOOLCHAIN_FILE=Toolchain.cmake -G "Ninja" -S . -B build/build
	cmake --build build/build -- -v

run: txt xml html sonarqube coveralls

coverage.json:
	cd build/build && ./gcovrtest
	$(GCOVR) --json coverage.json --object-directory=build/build

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

xml: coverage.json
	$(GCOVR) -a $< -x -o coverage.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build
	rm -f coverage*.* sonarqube*.* coveralls.json

=== gcovr/tests/config-output/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: html

html:
	./testcase
	$(GCOVR) -d --html --html-self-contained --config config/gcovr.config

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.html coverage.css

=== gcovr/tests/coveralls-ci/Makefile ===

# Unset all supported CI's
unexport GCOVR_TEST_SUITE
export GCOVR_TEST_SUITE_NO_GIT_COMMAND := 1

unexport TRAVIS_JOB_ID
unexport APPVEYOR_URL
unexport JENKINS_URL
unexport GITHUB_ACTIONS
unexport GITHUB_HEAD_REF

all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: coveralls

coveralls: coveralls.stub.json coveralls.travis.json coveralls.appveyor.json coveralls.jenkins.json coveralls.github-actions.json coveralls.github-actions-pr.json
	# Pass

coverage.json:
	./testcase
	$(GCOVR) -d --json-pretty -o $@

coveralls.stub.json: export GCOVR_TEST_SUITE := 1
coveralls.stub.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

coveralls.travis.json: export TRAVIS_JOB_ID := TRAVIS_JOB_ID
coveralls.travis.json: export TRAVIS_BUILD_NUMBER := TRAVIS_BUILD_NUMBER
coveralls.travis.json: export TRAVIS_PULL_REQUEST := 123
coveralls.travis.json: export TRAVIS_BRANCH := test_branch
coveralls.travis.json: export TRAVIS_COMMIT := TRAVIS_COMMIT
coveralls.travis.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

coveralls.appveyor.json: export APPVEYOR_URL := APPVEYOR_URL
coveralls.appveyor.json: export APPVEYOR_JOB_ID := APPVEYOR_JOB_ID
coveralls.appveyor.json: export APPVEYOR_JOB_NUMBER := APPVEYOR_JOB_NUMBER
coveralls.appveyor.json: export APPVEYOR_REPO_COMMIT := APPVEYOR_REPO_COMMIT
coveralls.appveyor.json: export APPVEYOR_PULL_REQUEST_NUMBER := 123
coveralls.appveyor.json: export APPVEYOR_REPO_BRANCH := test_branch
coveralls.appveyor.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

coveralls.jenkins.json: export JENKINS_URL := JENKINS_URL
coveralls.jenkins.json: export JOB_NAME := JOB_NAME
coveralls.jenkins.json: export BUILD_ID := BUILD_ID
coveralls.jenkins.json: export GIT_COMMIT := GIT_COMMIT
coveralls.jenkins.json: export CHANGE_ID := 123
coveralls.jenkins.json: export BRANCH_NAME := test_branch
coveralls.jenkins.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

coveralls.github-actions.json: export GITHUB_ACTIONS := GITHUB_ACTIONS
coveralls.github-actions.json: export GITHUB_WORKFLOW := GITHUB_WORKFLOW
coveralls.github-actions.json: export GITHUB_RUN_ID := GITHUB_RUN_ID
coveralls.github-actions.json: export GITHUB_SHA := GITHUB_SHA
coveralls.github-actions.json: export GITHUB_REF := refs/head/test_branch
coveralls.github-actions.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

coveralls.github-actions-pr.json: export GITHUB_ACTIONS := GITHUB_ACTIONS
coveralls.github-actions-pr.json: export GITHUB_WORKFLOW := GITHUB_WORKFLOW
coveralls.github-actions-pr.json: export GITHUB_RUN_ID := GITHUB_RUN_ID
coveralls.github-actions-pr.json: export GITHUB_SHA := GITHUB_SHA
coveralls.github-actions-pr.json: export GITHUB_HEAD_REF := refs/pull/123/merge
coveralls.github-actions-pr.json: export GITHUB_REF := test_branch
coveralls.github-actions-pr.json: coverage.json
	$(GCOVR) --add-tracefile $< --coveralls $@

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.* coveralls.*.json

=== debian/changelog ===
gcovr (5.0-2) unstable; urgency=medium

  * Fix FTBFS due to false assembly of PYTHONPATH during build
    (Closes: #1002411)

 -- Wolfgang Silbermayr <wolfgang@silbermayr.at>  Wed, 22 Dec 2021 18:46:13 +0100

gcovr (5.0-1) unstable; urgency=medium

  * New upstream version 5.0
  * Drop dependency on lcov (Closes: #987818)
  * Generate manpage at build time
  * Add Upstream-Contact to debian/copyright
  * Update debian/changelog to reflect recent changes

 -- Wolfgang Silbermayr <wolfgang@silbermayr.at>  Mon, 23 Aug 2021 07:55:04 +0200

## gcovr 5.2

=== doc/requirements.txt ===
sphinx
sphinx_rtd_theme
sphinxcontrib-autoprogram >= 0.1.5

=== gcovr/tests/add_coverages/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
 CFLAGS= -fprofile-arcs -ftest-coverage -fPIC
+export GCOVR_TEST_SUITE_NO_GIT_COMMAND := 1
 
 all:
 	$(CXX) $(CFLAGS) -c foo.cpp -o foo.o
@@ -10,23 +11,23 @@
 
 run: txt xml html sonarqube json json_summary coveralls
 
-# Enable JSON output via the --json-pretty mode.
+# Enable JSON output via the --json-pretty --json mode.
 # However, this option cannot take a filename directly
 # so that "-o" is used.
 coverage_foo.json:
 	./testcase_foo
 	$(GCOVR) -d --json-pretty -o $@
 
-# Just use --json and pass the output filename directly.
+# Just use --json-pretty and --json and pass the output filename directly.
 coverage_bar.json:
 	./testcase_bar
-	$(GCOVR) -d --json $@
+	$(GCOVR) -d --json-pretty --json $@
 
 txt: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a coverage_foo.json -a coverage_bar.json -o coverage.txt
 
 xml: coverage_foo.json coverage_bar.json
-	$(GCOVR) -a coverage_foo.json -a coverage_bar.json -x -o coverage.xml
+	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --cobertura-pretty --cobertura coverage.xml
 
 html: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --html-details -o coverage.html
@@ -34,7 +35,7 @@
 sonarqube: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --sonarqube sonarqube.xml
 
-# Use both --json and --json-pretty here
+# Use both --json-pretty --json here
 json: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a 'coverage_*.json' --json-pretty --json coverage.json

=== gcovr/tests/bad++char/Makefile ===
--- 
+++ 
@@ -5,13 +5,13 @@
 
 coverage.json:
 	./testcase
-	$(GCOVR) --json coverage.json
+	$(GCOVR) --json-pretty --json coverage.json
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
 
 xml: coverage.json
-	$(GCOVR) -a $< -x -o coverage.xml
+	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml
 
 html: coverage.json
 	$(GCOVR) -a $< --html-details -o coverage.html
@@ -20,7 +20,7 @@
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml
 
 coveralls: coverage.json
-	$(GCOVR) -a $< --coveralls coveralls.json
+	$(GCOVR) -a $< --coveralls-pretty --coveralls coveralls.json
 
 json_summary:
 	./testcase

=== gcovr/tests/cmake_oos/Makefile ===
--- 
+++ 
@@ -7,10 +7,10 @@
 #   gcovrtest
 
 BASE_OS:=$(shell uname | cut -d'-' -f1)
-ifeq ($(BASE_OS),MSYS_NT)
+ifeq ($(filter $(BASE_OS),MSYS_NT MINGW64_NT),)
+  CMAKE_GENERATOR := "Unix Makefiles"
+else
   CMAKE_GENERATOR := "MSYS Makefiles"
-else
-  CMAKE_GENERATOR := "Unix Makefiles"
 endif
 
 all:
@@ -24,19 +24,19 @@
 
 coverage.json:
 	cd build && ./gcovrtest
-	$(GCOVR) --json coverage.json
+	$(GCOVR) --json-pretty --json coverage.json
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
 
 xml: coverage.json
-	$(GCOVR) -a $< -x -o coverage.xml
+	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml
 
 html: coverage.json
 	$(GCOVR) -a $< --html-details -o coverage.html
 
 coveralls: coverage.json
-	$(GCOVR) -a $<  --coveralls coveralls.json
+	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json
 
 sonarqube: coverage.json
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

=== gcovr/tests/cmake_oos_ninja/Makefile ===
--- 
+++ 
@@ -10,19 +10,19 @@
 
 coverage.json:
 	cd build/build && ./gcovrtest
-	$(GCOVR) --json coverage.json --object-directory=build/build
+	$(GCOVR) --json-pretty --json coverage.json --object-directory=build/build
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
 
 xml: coverage.json
-	$(GCOVR) -a $< -x -o coverage.xml
+	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml
 
 html: coverage.json
 	$(GCOVR) -a $< --html-details -o coverage.html
 
 coveralls: coverage.json
-	$(GCOVR) -a $<  --coveralls coveralls.json
+	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json
 
 sonarqube: coverage.json
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

=== gcovr/tests/coveralls-ci/Makefile ===
--- 
+++ 
@@ -19,11 +19,11 @@
 
 coverage.json:
 	./testcase
-	$(GCOVR) -d --json-pretty -o $@
+	$(GCOVR) -d --json-pretty --json -o $@
 
 coveralls.stub.json: export GCOVR_TEST_SUITE := 1
 coveralls.stub.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 coveralls.travis.json: export TRAVIS_JOB_ID := TRAVIS_JOB_ID
 coveralls.travis.json: export TRAVIS_BUILD_NUMBER := TRAVIS_BUILD_NUMBER
@@ -31,7 +31,7 @@
 coveralls.travis.json: export TRAVIS_BRANCH := test_branch
 coveralls.travis.json: export TRAVIS_COMMIT := TRAVIS_COMMIT
 coveralls.travis.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 coveralls.appveyor.json: export APPVEYOR_URL := APPVEYOR_URL
 coveralls.appveyor.json: export APPVEYOR_JOB_ID := APPVEYOR_JOB_ID
@@ -40,7 +40,7 @@
 coveralls.appveyor.json: export APPVEYOR_PULL_REQUEST_NUMBER := 123
 coveralls.appveyor.json: export APPVEYOR_REPO_BRANCH := test_branch
 coveralls.appveyor.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 coveralls.jenkins.json: export JENKINS_URL := JENKINS_URL
 coveralls.jenkins.json: export JOB_NAME := JOB_NAME
@@ -49,7 +49,7 @@
 coveralls.jenkins.json: export CHANGE_ID := 123
 coveralls.jenkins.json: export BRANCH_NAME := test_branch
 coveralls.jenkins.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 coveralls.github-actions.json: export GITHUB_ACTIONS := GITHUB_ACTIONS
 coveralls.github-actions.json: export GITHUB_WORKFLOW := GITHUB_WORKFLOW
@@ -57,7 +57,7 @@
 coveralls.github-actions.json: export GITHUB_SHA := GITHUB_SHA
 coveralls.github-actions.json: export GITHUB_REF := refs/head/test_branch
 coveralls.github-actions.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 coveralls.github-actions-pr.json: export GITHUB_ACTIONS := GITHUB_ACTIONS
 coveralls.github-actions-pr.json: export GITHUB_WORKFLOW := GITHUB_WORKFLOW
@@ -66,7 +66,7 @@
 coveralls.github-actions-pr.json: export GITHUB_HEAD_REF := refs/pull/123/merge
 coveralls.github-actions-pr.json: export GITHUB_REF := test_branch
 coveralls.github-actions-pr.json: coverage.json
-	$(GCOVR) --add-tracefile $< --coveralls $@
+	$(GCOVR) --add-tracefile $< --coveralls-pretty --coveralls $@
 
 clean:
 	rm -f testcase

=== gcovr/tests/csv/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: csv

csv:
	./testcase
	$(GCOVR) -d --csv -o coverage.csv

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.csv

=== gcovr/tests/decisions-neg-delta/Makefile ===
all:
	$(CXX) -std=c++11 -fprofile-arcs -ftest-coverage -O0 main.cpp -o testcase

run: html json

coverage.json:
	./testcase
	$(GCOVR) --verbose --decisions --json-pretty --json -o coverage.json

html: coverage.json
	$(GCOVR) --verbose -a coverage.json --decisions --html-details -o coverage.html

json: coverage.json
	# pass

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.*

=== gcovr/tests/decisions/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage main.cpp -o testcase

run: html json

coverage.json:
	./testcase
	$(GCOVR) --verbose --decisions --json-pretty --json -o coverage.json

html: coverage.json
	$(GCOVR) --verbose -a coverage.json --decisions --html-details -o coverage.html

json: coverage.json
	# pass

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.*

=== gcovr/tests/dot/Makefile ===
CFLAGS= -fprofile-arcs -ftest-coverage -fPIC

all:
	$(CXX) $(CFLAGS) -c .subdir/A/file1.cpp -o .subdir/A/file1.o
	$(CXX) $(CFLAGS) -c .subdir/A/file2.cpp -o .subdir/A/file2.o
	$(CXX) $(CFLAGS) -c .subdir/A/file3.cpp -o .subdir/A/file3.o
	$(CXX) $(CFLAGS) -c .subdir/A/file4.cpp -o .subdir/A/file4.o
	$(CXX) $(CFLAGS) -c .subdir/A/C/file5.cpp -o .subdir/A/C/file5.o
	$(CXX) $(CFLAGS) -c .subdir/A/C/D/file6.cpp -o .subdir/A/C/D/file6.o
	$(CXX) $(CFLAGS) -c .subdir/B/main.cpp -o .subdir/B/main.o
	$(CXX) $(CFLAGS) .subdir/A/file1.o .subdir/A/file2.o .subdir/A/file3.o .subdir/A/file4.o .subdir/A/C/file5.o .subdir/A/C/D/file6.o .subdir/B/main.o -o .subdir/testcase

run: txt xml html sonarqube coveralls

coverage.json:
	.subdir/testcase
	$(GCOVR) -r . --json-pretty --json $@

txt: coverage.json
	$(GCOVR) -r . -a $< -o coverage.txt

xml: coverage.json
	$(GCOVR) -r . -a $< --cobertura-pretty --cobertura coverage.xml

html: coverage.json
	$(GCOVR) -r . -a $< --html-details -o coverage.html

sonarqube: coverage.json
	$(GCOVR) -r . -a $< --sonarqube sonarqube.xml

coveralls: coverage.json
	$(GCOVR) -r . -a $< --coveralls-pretty --coveralls coveralls.json

clean:
	rm -f ./.subdir/testcase
	rm -f .*.gc* */*.gc* .*/*/*.gc* .*/*/*/*.gc* .*/*/*/*/*.gc*
	rm -f .*.o .*/*.o .*/*/*.o .*/*/*/*.o .*/*/*/*/*.o
	rm -f coverage*.* sonarqube*.* coveralls.json

=== gcovr/tests/excl-branch/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: txt xml html sonarqube coveralls

coverage.json:
	./testcase
	$(GCOVR) --json-pretty --json $@

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

xml: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube sonarqube.xml

coveralls: coverage.json
	$(GCOVR) -a $< --coveralls-pretty --coveralls coveralls.json

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.* sonarqube*.* coveralls.json

=== gcovr/tests/excl-line-branch/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: txt xml html sonarqube json_summary coveralls

coverage.json:
	./testcase
	$(GCOVR) --exclude-unreachable-branches --json-pretty --json $@

txt: coverage.json
	$(GCOVR) -a $< -b -o coverage.txt

xml: coverage.json
	$(GCOVR) -a $< -b --cobertura-pretty --cobertura coverage.xml

html: coverage.json
	$(GCOVR) -a $< -b --html-details -o coverage.html

sonarqube: coverage.json
	$(GCOVR) -a $< -b --sonarqube sonarqube.xml

coveralls: coverage.json
	$(GCOVR) -a $< -b --coveralls-pretty --coveralls coveralls.json

json_summary:
	./testcase
	$(GCOVR) --exclude-unreachable-branches -b -d --json-summary-pretty -o summary_coverage.json

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.* sonarqube*.* summary_coverage.json coveralls.json

=== debian/changelog ===
gcovr (5.2-1) unstable; urgency=medium

  * New usptream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 14 Aug 2022 13:11:55 +0200

## gcovr 6.0

=== gcovr/tests/add_coverages/Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 	$(CXX) $(CFLAGS) -DBAR -c main.cpp -o main_bar.o
 	$(CXX) $(CFLAGS) main_bar.o bar.o -o testcase_bar
 
-run: txt xml html sonarqube json json_summary coveralls
+run: txt cobertura html sonarqube json json_summary coveralls
 
 # Enable JSON output via the --json-pretty --json mode.
 # However, this option cannot take a filename directly
@@ -26,8 +26,8 @@
 txt: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a coverage_foo.json -a coverage_bar.json -o coverage.txt
 
-xml: coverage_foo.json coverage_bar.json
-	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --cobertura-pretty --cobertura coverage.xml
+cobertura: coverage_foo.json coverage_bar.json
+	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --cobertura-pretty --cobertura cobertura.xml
 
 html: coverage_foo.json coverage_bar.json
 	$(GCOVR) -a coverage_foo.json -a coverage_bar.json --html-details -o coverage.html
@@ -49,4 +49,4 @@
 	rm -f testcase_*
 	rm -f *.gc*
 	rm -f *.o
-	rm -f coverage*.* sonarqube*.* summary_coverage.json coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* summary_coverage.json coveralls.json

=== gcovr/tests/bad++char/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 all:
 	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase
 
-run: txt xml html sonarqube json_summary coveralls
+run: txt cobertura html sonarqube json_summary coveralls
 
 coverage.json:
 	./testcase
@@ -10,8 +10,8 @@
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
 
-xml: coverage.json
-	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml
+cobertura: coverage.json
+	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml
 
 html: coverage.json
 	$(GCOVR) -a $< --html-details -o coverage.html
@@ -29,4 +29,4 @@
 clean:
 	rm -f testcase
 	rm -f *.gc*
-	rm -f coverage*.* sonarqube*.* summary_coverage.json coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* summary_coverage.json coveralls.json

=== gcovr/tests/calls/Makefile ===
all: testcase

GCOVR ?= gcovr

testcase:
	$(CXX) -fprofile-arcs -ftest-coverage callcov.c -o testcase

run: html json

html: coverage.json
	$(GCOVR) --calls --html --add-tracefile $< -o coverage.html --html-details

json: coverage.json

coverage.json:
	./testcase
	${GCOVR} --calls --json -o first.json
	./testcase
	${GCOVR} --calls --json -o second.json
	${GCOVR} --calls --add-tracefile first.json --add-tracefile second.json --json -o $@

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.*
	rm -f *.json

=== gcovr/tests/cmake_gtest/Makefile ===

all:
	@echo "CC:   ${CC} (origin: $(origin CC))"
	@echo "CXX:  ${CXX} (origin: $(origin CXX))"
	@echo "GCOV: ${GCOV} (origin: $(origin GCOV))"
	cmake -G "Ninja" -DCMAKE_BUILD_TYPE=PROFILE -S . -B build
	cmake --build build -- -v

run: txt cobertura html sonarqube coveralls

coverage.json:
	cd build && ./gcovr_gtest
	$(GCOVR) --filter source/ --json-pretty --json coverage.json --object-directory=build

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build
	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/cmake_oos/Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 	@echo "CXX:  ${CXX} (origin: $(origin CXX))"
 	@echo "GCOV: ${GCOV} (origin: $(origin GCOV))"
 	mkdir -p build
-	cd build && cmake -G $(CMAKE_GENERATOR) -DCMAKE_BUILD_TYPE=PROFILE -DCMAKE_TOOLCHAIN_FILE=../Toolchain.cmake .. && make
+	cd build && cmake -G $(CMAKE_GENERATOR) -DCMAKE_BUILD_TYPE=PROFILE .. && make
 
-run: txt xml html sonarqube coveralls
+run: txt cobertura html sonarqube coveralls
 
 coverage.json:
 	cd build && ./gcovrtest
@@ -29,8 +29,8 @@
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
 
-xml: coverage.json
-	$(GCOVR) -a $< --cobertura-pretty --cobertura coverage.xml
+cobertura: coverage.json
+	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml
 
 html: coverage.json
 	$(GCOVR) -a $< --html-details -o coverage.html
@@ -43,4 +43,4 @@
 
 clean:
 	rm -rf build
-	rm -f coverage*.* sonarqube*.* coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/cmake_oos_ninja/Makefile ===

all:
	@echo "CC:   ${CC} (origin: $(origin CC))"
	@echo "CXX:  ${CXX} (origin: $(origin CXX))"
	@echo "GCOV: ${GCOV} (origin: $(origin GCOV))"
	cp -f ../cmake_oos/main.cpp ./
	cmake -G "Ninja" -DCMAKE_BUILD_TYPE=PROFILE -S . -B build
	cmake --build build -- -v

run: txt cobertura html sonarqube coveralls

coverage.json:
	cd build && ./gcovrtest
	$(GCOVR) --json-pretty --json coverage.json --object-directory=build

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build main.cpp
	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/different-function-lines-separate/Makefile ===

all:
	mkdir -p build1 build2
	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase

run: json txt cobertura html sonarqube coveralls

coverage.json:
	cd build1 ; ./testcase
	cd build2 ; ./testcase
	$(GCOVR) --verbose --merge-mode-functions=separate --json-pretty --json coverage.json

json: coverage.json
	# Check error with default merge mode 'strict'.
	$(GCOVR) --verbose --add-tracefile $< > coverage.log 2>&1 ; test $$? -eq 1
	cat coverage.log
	grep -E 'AssertionError: Got function .*foo.* on multiple lines: 3, 5\.' coverage.log

txt: coverage.json
	$(GCOVR) -a $<  --merge-mode-functions=separate -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $<  --merge-mode-functions=separate --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $<  --merge-mode-functions=separate --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<   --merge-mode-functions=separate --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $<  --merge-mode-functions=separate --sonarqube -o sonarqube.xml

clean:
	rm -rf build1 build2
	rm -f *.gc* coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/different-function-lines-use-0/Makefile ===

all:
	mkdir -p build1 build2
	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase

run: txt cobertura html sonarqube coveralls

coverage.json:
	cd build1 ; ./testcase
	cd build2 ; ./testcase
	$(GCOVR) --json-pretty --json coverage.json ; test $$? -eq 1
	$(GCOVR) --verbose --merge-mode-functions=merge-use-line-0 --json-pretty --json coverage.json

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build1 build2
	rm -f *.gc* coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/different-function-lines-use-max/Makefile ===

all:
	mkdir -p build1 build2
	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase

run: txt cobertura html sonarqube coveralls

coverage.json:
	cd build1 ; ./testcase
	cd build2 ; ./testcase
	$(GCOVR) --verbose --merge-mode-functions=merge-use-line-max --json-pretty --json coverage.json

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build1 build2
	rm -f *.gc* coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/different-function-lines-use-min/Makefile ===

all:
	mkdir -p build1 build2
	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase

run: txt cobertura html sonarqube coveralls

coverage.json:
	cd build1 ; ./testcase
	cd build2 ; ./testcase
	$(GCOVR) --verbose --merge-mode-functions=merge-use-line-min --json-pretty --json coverage.json

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

coveralls: coverage.json
	$(GCOVR) -a $<  --coveralls-pretty --coveralls coveralls.json

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube -o sonarqube.xml

clean:
	rm -rf build1 build2
	rm -f *.gc* coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/dot/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 	$(CXX) $(CFLAGS) -c .subdir/B/main.cpp -o .subdir/B/main.o
 	$(CXX) $(CFLAGS) .subdir/A/file1.o .subdir/A/file2.o .subdir/A/file3.o .subdir/A/file4.o .subdir/A/C/file5.o .subdir/A/C/D/file6.o .subdir/B/main.o -o .subdir/testcase
 
-run: txt xml html sonarqube coveralls
+run: txt cobertura html sonarqube coveralls
 
 coverage.json:
 	.subdir/testcase
@@ -19,8 +19,8 @@
 txt: coverage.json
 	$(GCOVR) -r . -a $< -o coverage.txt
 
-xml: coverage.json
-	$(GCOVR) -r . -a $< --cobertura-pretty --cobertura coverage.xml
+cobertura: coverage.json
+	$(GCOVR) -r . -a $< --cobertura-pretty --cobertura cobertura.xml
 
 html: coverage.json
 	$(GCOVR) -r . -a $< --html-details -o coverage.html
@@ -35,4 +35,4 @@
 	rm -f ./.subdir/testcase
 	rm -f .*.gc* */*.gc* .*/*/*.gc* .*/*/*/*.gc* .*/*/*/*/*.gc*
 	rm -f .*.o .*/*.o .*/*/*.o .*/*/*/*.o .*/*/*/*/*.o
-	rm -f coverage*.* sonarqube*.* coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== gcovr/tests/excl-branch/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage -fPIC main.cpp -o testcase

run: txt cobertura html sonarqube coveralls

coverage.json:
	./testcase
	$(GCOVR) --json-pretty --json $@

txt: coverage.json
	$(GCOVR) -a $< -o coverage.txt

cobertura: coverage.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

html: coverage.json
	$(GCOVR) -a $< --html-details -o coverage.html

sonarqube: coverage.json
	$(GCOVR) -a $< --sonarqube sonarqube.xml

coveralls: coverage.json
	$(GCOVR) -a $< --coveralls-pretty --coveralls coveralls.json

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json

=== debian/changelog ===
gcovr (6.0-1) unstable; urgency=medium

  * New upstream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 09 Jul 2023 09:38:01 +0200

## gcovr 7.0

=== doc/requirements.txt ===
sphinx
sphinx_rtd_theme
sphinxcontrib-autoprogram >= 0.1.5
rst2html5

=== gcovr/tests/calls/Makefile ===
all: testcase

GCOVR ?= gcovr

testcase:
	$(CXX) -fprofile-arcs -ftest-coverage callcov.c -o testcase

run: html json

html: coverage.json
	$(GCOVR) --calls --html --json-add-tracefile $< -o coverage.html --html-details

json: coverage.json

coverage.json:
	./testcase
	${GCOVR} --calls --json -o first.json
	./testcase
	${GCOVR} --calls --json -o second.json
	${GCOVR} --calls --json-add-tracefile first.json --json-add-tracefile second.json --json -o $@

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.*
	rm -f *.json

=== gcovr/tests/cmake_gtest/Makefile ===
--- 
+++ 
@@ -6,11 +6,11 @@
 	cmake -G "Ninja" -DCMAKE_BUILD_TYPE=PROFILE -S . -B build
 	cmake --build build -- -v
 
-run: txt cobertura html sonarqube coveralls
+run: txt cobertura html sonarqube jacoco coveralls
 
 coverage.json:
 	cd build && ./gcovr_gtest
-	$(GCOVR) --filter source/ --json-pretty --json coverage.json --object-directory=build
+	$(GCOVR) --filter source/ --json-pretty --json coverage.json --gcov-object-directory=build
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
@@ -27,6 +27,9 @@
 sonarqube: coverage.json
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml
 
+jacoco: coverage.json
+	$(GCOVR) -a $< --jacoco -o jacoco.xml
+
 clean:
 	rm -rf build
-	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* jacoco*.* coveralls.json

=== gcovr/tests/cmake_oos/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12 FATAL_ERROR)

project(gcovrtest)

    # This flags are used if cmake is called with -DCMAKE_BUILD_TYPE=PROFILE
    set(CMAKE_C_FLAGS_PROFILE --coverage)
    set(CMAKE_CXX_FLAGS_PROFILE --coverage)

    add_executable(gcovrtest main.cpp)

=== gcovr/tests/cmake_oos/Makefile ===
--- 
+++ 
@@ -20,7 +20,7 @@
 	mkdir -p build
 	cd build && cmake -G $(CMAKE_GENERATOR) -DCMAKE_BUILD_TYPE=PROFILE .. && make
 
-run: txt cobertura html sonarqube coveralls
+run: txt cobertura html sonarqube jacoco coveralls
 
 coverage.json:
 	cd build && ./gcovrtest
@@ -41,6 +41,9 @@
 sonarqube: coverage.json
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml
 
+jacoco: coverage.json
+	$(GCOVR) -a $< --jacoco -o jacoco.xml
+
 clean:
 	rm -rf build
-	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* jacoco*.* coveralls.json

=== gcovr/tests/cmake_oos_ninja/Makefile ===
--- 
+++ 
@@ -7,11 +7,11 @@
 	cmake -G "Ninja" -DCMAKE_BUILD_TYPE=PROFILE -S . -B build
 	cmake --build build -- -v
 
-run: txt cobertura html sonarqube coveralls
+run: txt cobertura html sonarqube jacoco coveralls
 
 coverage.json:
 	cd build && ./gcovrtest
-	$(GCOVR) --json-pretty --json coverage.json --object-directory=build
+	$(GCOVR) --json-pretty --json coverage.json --gcov-object-directory=build
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
@@ -28,6 +28,9 @@
 sonarqube: coverage.json
 	$(GCOVR) -a $< --sonarqube -o sonarqube.xml
 
+jacoco: coverage.json
+	$(GCOVR) -a $< --jacoco -o jacoco.xml
+
 clean:
 	rm -rf build main.cpp
-	rm -f coverage*.* cobertura*.* sonarqube*.* coveralls.json
+	rm -f coverage*.* cobertura*.* sonarqube*.* jacoco*.* coveralls.json

=== gcovr/tests/coexisting_object_directories-from_build_dir-without_object_dir/Makefile ===

build.%:
	mkdir -p build/$* && cmake -G "Ninja" -DCMAKE_BUILD_TYPE=PROFILE -S . -B build/$* -D ODD=$(if $(filter b,$*),OFF,ON)
	cmake --build build/$* -- -v

all: build.a build.b build.c

run: txt cobertura html sonarqube coveralls

.NOTPARALLEL: coverage.a.json coverage.b.json coverage.c.json

coverage.%.json:
	$(eval base_dir := $(shell pwd))
	$(eval build_dir := $(base_dir)/build/$*)
	cd $(build_dir) && ./parallel_call
	cd $(build_dir) && $(GCOVR) --json-pretty --json $(base_dir)/$@ --root $(base_dir) $(build_dir)

coverage.%.txt: coverage.%.json
	$(GCOVR) -a $< -o $@

txt: coverage.a.txt coverage.b.txt coverage.c.txt

cobertura.%.xml: coverage.%.json
	$(GCOVR) -a $< --cobertura-pretty --cobertura $@

cobertura: cobertura.a.xml cobertura.b.xml cobertura.c.xml

coverage.%.html: coverage.%.json
	$(GCOVR) -a $< --html-details -o $@

html: coverage.a.html coverage.b.html coverage.c.html

coveralls.%.json: coverage.%.json
	$(GCOVR) -a $< --coveralls-pretty --coveralls $@

coveralls: coveralls.a.json coveralls.b.json coveralls.c.json

sonarqube.%.xml: coverage.%.json
		$(GCOVR) -a $< --sonarqube -o $@

sonarqube: sonarqube.a.xml sonarqube.b.xml sonarqube.c.xml

clean:
	rm -rf build
	rm -f run.*.done
	rm -f coverage.*.* cobertura.*.* sonarqube.*.* coveralls.*.*

=== gcovr/tests/config-output/Makefile ===
--- 
+++ 
@@ -5,7 +5,9 @@
 
 html:
 	./testcase
-	$(GCOVR) -d --html --html-self-contained --config config/gcovr.config
+	$(GCOVR) --html --html-self-contained --config config/gcovr.error.config 2>&1 | grep -F "gcovr.error.config: 1: gcov-ignore-parse-errors: must be one of"
+	$(GCOVR) --html --html-self-contained --config config/gcovr.txt-branch.config 2>&1 | grep -F "(WARNING) Deprecated config key txt-branch used, please use 'txt-metric=branch' instead."
+	$(GCOVR) --html --html-self-contained --config config/gcovr.config
 
 clean:
 	rm -f testcase

=== gcovr/tests/decisions-neg-delta/Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 all:
 	$(CXX) -std=c++11 -fprofile-arcs -ftest-coverage -O0 main.cpp -o testcase
 
-run: html json
+run: html txt json
 
 coverage.json:
 	./testcase
@@ -10,6 +10,9 @@
 html: coverage.json
 	$(GCOVR) --verbose -a coverage.json --decisions --html-details -o coverage.html
 
+txt: coverage.json
+	$(GCOVR) --verbose -a coverage.json --txt-metric decision -o coverage.txt
+
 json: coverage.json
 	# pass

=== gcovr/tests/decisions/Makefile ===
all:
	$(CXX) -fprofile-arcs -ftest-coverage main.cpp switch_test.cpp -o testcase

run: html txt json

coverage.json:
	./testcase
	$(GCOVR) --keep --verbose --decisions --json-pretty --json -o coverage.json

html: coverage.json
	$(GCOVR) --verbose -a coverage.json --decisions --html-details -o coverage.html

txt: coverage.json
	$(GCOVR) --verbose -a coverage.json --txt-metric decision -o coverage.txt

json: coverage.json
	# pass

clean:
	rm -f testcase
	rm -f *.gc*
	rm -f coverage*.*

=== gcovr/tests/different-function-lines-separate/Makefile ===
--- 
+++ 
@@ -4,7 +4,7 @@
 	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
 	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase
 
-run: json txt cobertura html sonarqube coveralls
+run: json txt lcov cobertura html sonarqube coveralls
 
 coverage.json:
 	cd build1 ; ./testcase
@@ -13,12 +13,15 @@
 
 json: coverage.json
 	# Check error with default merge mode 'strict'.
-	$(GCOVR) --verbose --add-tracefile $< > coverage.log 2>&1 ; test $$? -eq 1
+	$(GCOVR) --verbose --json-add-tracefile $< > coverage.log 2>&1 ; test $$? -eq 64
 	cat coverage.log
-	grep -E 'AssertionError: Got function .*foo.* on multiple lines: 3, 5\.' coverage.log
+	grep -E 'Got function .*foo.* on multiple lines: 3, 5\.' coverage.log
 
 txt: coverage.json
 	$(GCOVR) -a $<  --merge-mode-functions=separate -o coverage.txt
+
+lcov: coverage.json
+	$(GCOVR) -a $<  --merge-mode-functions=separate --lcov coverage.lcov
 
 cobertura: coverage.json
 	$(GCOVR) -a $<  --merge-mode-functions=separate --cobertura-pretty --cobertura cobertura.xml

=== gcovr/tests/different-function-lines-use-0/Makefile ===
--- 
+++ 
@@ -4,16 +4,19 @@
 	cd build1 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC ../main.c -o testcase
 	cd build2 ; $(CXX) -fprofile-arcs -ftest-coverage -fPIC -DFOO_OTHER_LINE ../main.c -o testcase
 
-run: txt cobertura html sonarqube coveralls
+run: txt lcov cobertura html sonarqube coveralls
 
 coverage.json:
 	cd build1 ; ./testcase
 	cd build2 ; ./testcase
-	$(GCOVR) --json-pretty --json coverage.json ; test $$? -eq 1
+	$(GCOVR) --json-pretty --json coverage.json ; test $$? -eq 64
 	$(GCOVR) --verbose --merge-mode-functions=merge-use-line-0 --json-pretty --json coverage.json
 
 txt: coverage.json
 	$(GCOVR) -a $< -o coverage.txt
+
+lcov: coverage.json
+	$(GCOVR) -a $< --lcov coverage.lcov
 
 cobertura: coverage.json
 	$(GCOVR) -a $< --cobertura-pretty --cobertura cobertura.xml

=== debian/changelog ===
gcovr (7.0-1) unstable; urgency=medium

  * New usptream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 29 Jan 2024 09:12:26 +0100

=== debian/control ===
Source: gcovr
Section: devel
Priority: optional
Maintainer: Wolfgang Silbermayr <wolfgang@silbermayr.at>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>
Build-Depends: debhelper (>= 11),
               python3,
               python3-setuptools,
               dh-python,
               help2man,
               python3-importlib-metadata,
               python3-lxml,
X-Python3-Version: >= 3.6
Standards-Version: 4.2.1
Homepage: http://gcovr.com/
Vcs-Browser: https://salsa.debian.org/debian/gcovr
Vcs-Git: https://salsa.debian.org/debian/gcovr.git

Package: gcovr
Architecture: all
Depends: ${misc:Depends},
         ${python3:Depends},
         python3-pkg-resources,
Description: Manages the compilation of coverage information from gcov
 The gcovr command provides a utility for running the gcov command and
 summarizing code coverage results. This command is inspired by the
 Python coverage.py package, which provides a similar utility in
 Python. Further, gcovr can be viewed as a command-line alternative of
 the lcov utility, which runs gcov and generates an HTML output.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk

PYTHON3_VERSIONS = $(shell py3versions -r)
PYTHON3_DEFAULT_VERSION = $(shell py3versions -d)
pyalldo = set -e; $(foreach py, $(PYTHON3_VERSIONS), $(py) $(1);)

BIN_NAME = gcovr
BIN_DESCRIPTION = "generate simple coverage reports"

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_installman:
	PYTHONPATH=debian/gcovr/usr/lib/$(PYTHON3_DEFAULT_VERSION)/dist-packages \
	help2man \
		--name $(BIN_DESCRIPTION) \
		--no-info \
		--version-string $(DEB_VERSION_UPSTREAM) \
		--output debian/$(BIN_NAME).1 \
		debian/gcovr/usr/bin/gcovr
	dh_installman

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build
	rm -rf *.egg-info

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/gcovr-$1.tar.gz/" \
   https://github.com/gcovr/gcovr/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## gcovr 7.2

=== gcovr/tests/nested/Makefile ===
CFLAGS= -fprofile-arcs -ftest-coverage -fPIC

all:
	$(CXX) $(CFLAGS) -c subdir/A/file1.cpp -o subdir/A/file1.o
	$(CXX) $(CFLAGS) -c subdir/A/file2.cpp -o subdir/A/file2.o
	$(CXX) $(CFLAGS) -c subdir/A/file3.cpp -o subdir/A/file3.o
	$(CXX) $(CFLAGS) -c subdir/A/file4.cpp -o subdir/A/file4.o
	$(CXX) $(CFLAGS) -c subdir/A/file7.cpp -o subdir/A/file7.o
	$(CXX) $(CFLAGS) -c subdir/A/C/file5.cpp -o subdir/A/C/file5.o
	$(CXX) $(CFLAGS) -c subdir/A/C/D/file6.cpp -o subdir/A/C/D/file6.o
	$(CXX) $(CFLAGS) -c subdir/B/main.cpp -o subdir/B/main.o
	$(CXX) $(CFLAGS) subdir/A/file1.o subdir/A/file2.o subdir/A/file3.o subdir/A/file4.o subdir/A/C/file5.o subdir/A/C/D/file6.o subdir/A/file7.o subdir/B/main.o -o subdir/testcase

run: txt xml html

txt:
	./subdir/testcase
	../../../scripts/gcovr -r subdir -d -o coverage.txt

xml:
	./subdir/testcase
	../../../scripts/gcovr -r subdir -d -x -o coverage.xml

html:
	./subdir/testcase
	../../../scripts/gcovr -r subdir -d --html --html-details -o coverage.html

clean:
	rm -f ./subdir/testcase
	rm -f *.gc* */*.gc* */*/*.gc* */*/*/*.gc* */*/*/*/*.gc*
	rm -f *.o */*.o */*/*.o */*/*/*.o */*/*/*/*.o
	rm -f coverage.txt coverage.xml coverage*.html

=== debian/changelog ===
gcovr (7.2-1) unstable; urgency=medium

  * New usptream release

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 23 Apr 2024 22:09:47 +0200
